/******************************************************************************
 * Copyright(c) 2008 - 2010 Realtek Corporation. All rights reserved.
 *
 * Based on the r8180 driver, which is:
 * Copyright 2004-2005 Andrea Merello <andreamrl@tiscali.it>, et al.
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110, USA
 *
 * The full GNU General Public License is included in this distribution in the
 * file called LICENSE.
 *
 * Contact Information:
 * Jerry chuang <wlanfae@realtek.com>
******************************************************************************/
#include "r8180.h"
#include "r8180_hw.h"
#include "r8180_gct.h"











u32 gct_chan[] = {
	0x0,	
	0x0, 
	0x1, 
	0x2, 
	0x3, 
	0x4, 
	0x5, 
	0x6, 
	0x7, 
	0x8, 
	0x9, 
	0xa, 
	0xb, 
	0xc, 
	0xd, 
};
	
int gct_encode[16] = { 
	0, 8, 4, 0xC,
	2, 0xA, 6, 0xE,
	1, 9, 5, 0xD,
	3, 0xB, 7, 0xF 
};

void gct_rf_stabilize(struct net_device *dev)
{
	force_pci_posting(dev);
	mdelay(3); 
}


void write_gct(struct net_device *dev, u8 adr, u32 data) 
{
	u32 phy_config;

	phy_config =  gct_encode[(data & 0xf00) >> 8];
	phy_config |= gct_encode[(data & 0xf0) >> 4 ] << 4;
	phy_config |= gct_encode[(data & 0xf)       ] << 8;
	phy_config |= gct_encode[(adr >> 1) & 0xf   ] << 12;
	phy_config |=            (adr & 1 )           << 16;
	phy_config |= gct_encode[(data & 0xf000)>>12] << 24;
	
	phy_config |= 0x90000000; 

	
	write_nic_dword(dev,PHY_CONFIG,phy_config);
#ifdef DEBUG_GCT
	DMESG("Writing GCT: %x (adr %x)",phy_config,adr);
#endif
	gct_rf_stabilize(dev);
}



void gct_write_phy_antenna(struct net_device *dev,short ch)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	u8 ant;

	ant = GCT_ANTENNA;
	if(priv->antb) 
		ant |= BB_ANTENNA_B;
	if(ch == 14)
		ant |= BB_ANTATTEN_CHAN14;
	write_phy(dev,0x10,ant);
}


void gct_rf_set_chan(struct net_device *dev, short ch)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	u32 txpw = 0xff & priv->chtxpwr[ch]; 
	u32 chan = gct_chan[ch];
	
#ifdef DEBUG_GCT 
	DMESG("Gct set channel");
#endif	
	write_gct(dev,0x15,0);
 	write_gct(dev,6, txpw);
	write_gct(dev,0x15, 0x10);
	write_gct(dev,0x15,0);
    
	write_gct(dev,7, 0);
      	write_gct(dev,0xB, chan);
      	write_gct(dev,7, 0x1000);
      	
#ifdef DEBUG_GCT 
	DMESG("Gct set channel > write phy antenna");
#endif	
      

	gct_write_phy_antenna(dev,ch);
	
}


void gct_rf_close(struct net_device *dev)
{
	u32 anaparam;
	
	anaparam = read_nic_dword(dev,ANAPARAM);
	anaparam &= 0x000fffff;
	anaparam |= 0x3f900000;
	rtl8180_set_anaparam(dev, anaparam);
	
	write_gct(dev, 0x7, 0);
	write_gct(dev, 0x1f, 0x45);
	write_gct(dev, 0x1f, 0x5);
	write_gct(dev, 0x0, 0x8e4);
}


void gct_rf_init(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	
	
	write_nic_byte(dev,PHY_DELAY,0x6);	
	write_nic_byte(dev,CARRIER_SENSE_COUNTER,0x4c); 
	
	
	write_gct(dev,0x1f,0);
	write_gct(dev,0x1f,0);
	write_gct(dev,0x1f,0x40);
	write_gct(dev,0x1f,0x60);
	write_gct(dev,0x1f,0x61);
	write_gct(dev,0x1f,0x61);
	write_gct(dev,0x0,0xae4);
	write_gct(dev,0x1f,0x1);
	write_gct(dev,0x1f,0x41);
	write_gct(dev,0x1f,0x61);
	write_gct(dev,0x1,0x1a23);
	write_gct(dev,0x2,0x4971);
	write_gct(dev,0x3,0x41de);
	write_gct(dev,0x4,0x2d80);
#ifdef GCT_EXPERIMENT1
	write_gct(dev,0x5,0x685f);  
#else
	write_gct(dev,0x5,0x61ff);   
#endif
#ifdef GCT_EXPERIMENT2
	write_gct(dev,0x6,0xe);
#else
	write_gct(dev,0x6,0x0);
#endif
	write_gct(dev,0x7,0x0);
	write_gct(dev,0x8,0x7533);
	write_gct(dev,0x9,0xc401);
	write_gct(dev,0xa,0x0);
	write_gct(dev,0xc,0x1c7);
	write_gct(dev,0xd,0x29d3);
	write_gct(dev,0xe,0x2e8);
	write_gct(dev,0x10,0x192);
#ifdef GCT_EXPERIMENT3
	write_gct(dev,0x11,0x246);
#else
	write_gct(dev,0x11,0x248);
#endif
	write_gct(dev,0x12,0x0);
	write_gct(dev,0x13,0x20c4);
#ifdef GCT_EXPERIMENT4
	write_gct(dev,0x14,0xf488);
#else
	write_gct(dev,0x14,0xf4fc);
#endif
#ifdef GCT_EXPERIMENT5
	write_gct(dev,0x15,0xb152);
#else
	write_gct(dev,0x15,0x0);
#endif
#ifdef GCT_EXPERIMENT6
	write_gct(dev,0x1e,0x1);
#endif
	write_gct(dev,0x16,0x1500);

	write_gct(dev,0x7,0x1000);
	write_phy(dev,0,0xa8);
	
	
	write_phy(dev,3,0x0);
	write_phy(dev,4,0xc0); 
	write_phy(dev,5,0x90);
	write_phy(dev,6,0x1e);
	write_phy(dev,7,0x64);

#ifdef DEBUG_GCT 
	DMESG("Gct init> write phy antenna");
#endif	
	
	gct_write_phy_antenna(dev,priv->chan);
	
	write_phy(dev,0x11,0x88);
	if(!priv->diversity)
		write_phy(dev,0x12,0xc0);
	else
		write_phy(dev,0x12,0x40); 
	
	write_phy(dev,0x13,0x90 | priv->cs_treshold ); 
	
	write_phy(dev,0x19,0x0);
	write_phy(dev,0x1a,0xa0); 
	write_phy(dev,0x1b,0x44);

#ifdef DEBUG_GCT 
	DMESG("Gct init > set channel2");
#endif	
	
	gct_rf_set_chan(dev,priv->chan);
}
