/******************************************************************************
 * Copyright(c) 2008 - 2010 Realtek Corporation. All rights reserved.
 *
 * Based on the r8180 driver, which is:
 * Copyright 2004-2005 Andrea Merello <andreamrl@tiscali.it>, et al.
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110, USA
 *
 * The full GNU General Public License is included in this distribution in the
 * file called LICENSE.
 *
 * Contact Information:
 * Jerry chuang <wlanfae@realtek.com>
******************************************************************************/



#include "r8180.h"
#include "r8180_hw.h"
#include "r8180_max2820.h"



u32 maxim_chan[] = {
	0,	
	12, 
	17, 
	22, 
	27, 
	32, 
	37, 
	42, 
	47, 
	52, 
	57, 
	62, 
	67, 
	72, 
	84, 
};

#if 0	
void write_maxim(struct net_device *dev,u8 adr, u32 data) 
{

	int shift;
	short bit;
	u16 word;
	
	adr = adr &0xf;
	word = (u16)data & 0xfff;
	word |= (adr<<12);
	
	for(shift = 15;shift >=0; shift--){
		bit = word>>shift & 1;
		
		write_nic_dword(dev,PHY_CONFIG,BB_HOST_BANG | (bit<<BB_HOST_BANG_DATA));	
		
		read_nic_dword(dev,PHY_CONFIG);
		mdelay(2);
		
		write_nic_dword(dev,PHY_CONFIG,BB_HOST_BANG | 
		(bit<<BB_HOST_BANG_DATA) | BB_HOST_BANG_CLK); 
		
		read_nic_dword(dev,PHY_CONFIG);
		mdelay(1);
		
		write_nic_dword(dev,PHY_CONFIG,BB_HOST_BANG | 
		(bit<<BB_HOST_BANG_DATA));
		
		read_nic_dword(dev,PHY_CONFIG);
		mdelay(2);

	}
	write_nic_dword(dev,PHY_CONFIG,BB_HOST_BANG | (bit<<BB_HOST_BANG_DATA)|
					BB_HOST_BANG_EN);
	read_nic_dword(dev,PHY_CONFIG);
	mdelay(2);
	
	 * last 12 bits data shifted in
	 */
	write_nic_dword(dev,PHY_CONFIG,BB_HOST_BANG | (bit<<BB_HOST_BANG_DATA)|
					BB_HOST_BANG_EN | BB_HOST_BANG_CLK);
	read_nic_dword(dev,PHY_CONFIG);
	mdelay(2);
	
	write_nic_dword(dev,PHY_CONFIG,BB_HOST_BANG | (bit<<BB_HOST_BANG_DATA)|
					BB_HOST_BANG_EN);
	read_nic_dword(dev,PHY_CONFIG);
	mdelay(2);
	
	
#ifdef DEBUG_MAXIM
	DMESG("Writing maxim: %x (adr %x)",phy_config,adr);
#endif
	
}
#endif

void write_maxim(struct net_device *dev,u8 adr, u32 data) {
	u32 temp;
	temp =  0x90 + (data & 0xf);
	temp <<= 16;
	temp += adr;
	temp <<= 8;
	temp += (data >> 4) & 0xff;
#ifdef DEBUG_MAXIM
	DMESG("write_maxim: %08x", temp);
#endif	
	write_nic_dword(dev, PHY_CONFIG, temp);
	force_pci_posting(dev);
	mdelay(1);
}


void maxim_write_phy_antenna(struct net_device *dev,short ch)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	u8 ant;

	ant = MAXIM_ANTENNA;
	if(priv->antb) 
		ant |= BB_ANTENNA_B;
	if(ch == 14)
		ant |= BB_ANTATTEN_CHAN14;
	write_phy(dev,0x10,ant);
}


void maxim_rf_set_chan(struct net_device *dev, short ch)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	u32 txpw = 0xff & priv->chtxpwr[ch]; 
	u32 chan = maxim_chan[ch];
	
	 
	write_phy(dev,3,txpw);

	maxim_write_phy_antenna(dev,ch);
	write_maxim(dev,3,chan);
}


void maxim_rf_close(struct net_device *dev)
{
	write_phy(dev, 3, 0x8);
	write_maxim(dev, 1, 0);
}


void maxim_rf_init(struct net_device *dev)
{
	struct r8180_priv *priv = ieee80211_priv(dev);
	u32 anaparam;
	
	write_nic_byte(dev,PHY_DELAY,0x6);	
	write_nic_byte(dev,CARRIER_SENSE_COUNTER,0x4c); 
	
	anaparam = read_nic_dword(dev,ANAPARAM);
	anaparam = anaparam &~ (ANAPARAM_TXDACOFF_SHIFT);
	anaparam = anaparam &~ANAPARAM_PWR1_MASK;
	anaparam = anaparam &~ANAPARAM_PWR0_MASK;
	anaparam |= (MAXIM_ANAPARAM_PWR1_ON<<ANAPARAM_PWR1_SHIFT);
	anaparam |= (MAXIM_ANAPARAM_PWR0_ON<<ANAPARAM_PWR0_SHIFT);
	
	
	
	write_maxim(dev,0, 7); 
	write_maxim(dev,1, 0x1e); 
	write_maxim(dev,2, 1); 
	
	
	maxim_rf_set_chan(dev,priv->chan);
	 
	write_maxim(dev,4, 0x313); 
	
	
	write_maxim(dev,5, 0xf); 
	
	
	write_phy(dev,0,0x88); 
	write_phy(dev,3,0x8); 
	write_phy(dev,4,0xf8); 
	write_phy(dev,5,0x90); 
	write_phy(dev,6,0x1a); 
	write_phy(dev,7,0x64); 
	
	
	maxim_write_phy_antenna(dev,priv->chan);
	
	write_phy(dev,0x11,0x88); 
	if(priv->diversity)
		write_phy(dev,0x12,0xc7);
	else
		write_phy(dev,0x12,0x47); 
	
	write_phy(dev,0x13,0x9b); 
	
	write_phy(dev,0x19,0x0); 
	write_phy(dev,0x1a,0x9f); 
	
	maxim_rf_set_chan(dev,priv->chan);
}
